# Interface CAProtocolMessageValidatorType<T,R>

Type Parameters:
  `T` - The type of core messages
  `R` - The type of wire messages

All Known Implementing Classes:
  `CAI1Validation`, `CAIUVEventUpdated`, `CAUVAttachment`, `CAUVAttachmentKey`, `CAUVAuditEvent`, `CAUVAuditSearchParameters`, `CAUVCommandAuditSearchBegin`, `CAUVCommandAuditSearchNext`, `CAUVCommandAuditSearchPrevious`, `CAUVCommandFileDelete`, `CAUVCommandFileGet`, `CAUVCommandFilePut`, `CAUVCommandFileSearchBegin`, `CAUVCommandFileSearchNext`, `CAUVCommandFileSearchPrevious`, `CAUVCommandItemAttachmentAdd`, `CAUVCommandItemAttachmentRemove`, `CAUVCommandItemCreate`, `CAUVCommandItemDelete`, `CAUVCommandItemGet`, `CAUVCommandItemMetadataPut`, `CAUVCommandItemMetadataRemove`, `CAUVCommandItemSearchBegin`, `CAUVCommandItemSearchNext`, `CAUVCommandItemSearchPrevious`, `CAUVCommandItemSetName`, `CAUVCommandItemTypesAssign`, `CAUVCommandItemTypesRevoke`, `CAUVCommandLocationAttachmentAdd`, `CAUVCommandLocationAttachmentRemove`, `CAUVCommandLocationDelete`, `CAUVCommandLocationGet`, `CAUVCommandLocationList`, `CAUVCommandLocationMetadataPut`, `CAUVCommandLocationMetadataRemove`, `CAUVCommandLocationPut`, `CAUVCommandLocationTypesAssign`, `CAUVCommandLocationTypesRevoke`, `CAUVCommandLogin`, `CAUVCommandRolesAssign`, `CAUVCommandRolesGet`, `CAUVCommandRolesRevoke`, `CAUVCommandStockCount`, `CAUVCommandStockReposit`, `CAUVCommandStockSearchBegin`, `CAUVCommandStockSearchNext`, `CAUVCommandStockSearchPrevious`, `CAUVCommandTypePackageGetText`, `CAUVCommandTypePackageInstall`, `CAUVCommandTypePackageSearchBegin`, `CAUVCommandTypePackageSearchNext`, `CAUVCommandTypePackageSearchPrevious`, `CAUVCommandTypePackageUninstall`, `CAUVCommandTypePackageUpgrade`, `CAUVComparisonsExact`, `CAUVComparisonsFuzzy`, `CAUVComparisonsSet`, `CAUVDottedNames`, `CAUVError`, `CAUVFile`, `CAUVFileColumn`, `CAUVFileColumnOrdering`, `CAUVFileSearchParameters`, `CAUVId`, `CAUVIncludeDeleted`, `CAUVItem`, `CAUVItemColumn`, `CAUVItemColumnOrdering`, `CAUVItemID`, `CAUVItemSearchParameters`, `CAUVItemSerial`, `CAUVItemSummary`, `CAUVLocation`, `CAUVLocationMatch`, `CAUVLocationSummaries`, `CAUVLocationSummary`, `CAUVMessage`, `CAUVMetadata`, `CAUVMetadataElementMatch`, `CAUVMetadataValueMatch`, `CAUVResponseAuditSearch`, `CAUVResponseBlame`, `CAUVResponseError`, `CAUVResponseFileDelete`, `CAUVResponseFileGet`, `CAUVResponseFilePut`, `CAUVResponseFileSearch`, `CAUVResponseItemAttachmentAdd`, `CAUVResponseItemAttachmentRemove`, `CAUVResponseItemCreate`, `CAUVResponseItemDelete`, `CAUVResponseItemGet`, `CAUVResponseItemMetadataPut`, `CAUVResponseItemMetadataRemove`, `CAUVResponseItemSearch`, `CAUVResponseItemSetName`, `CAUVResponseItemTypesAssign`, `CAUVResponseItemTypesRevoke`, `CAUVResponseLocationAttachmentAdd`, `CAUVResponseLocationAttachmentRemove`, `CAUVResponseLocationDelete`, `CAUVResponseLocationGet`, `CAUVResponseLocationList`, `CAUVResponseLocationMetadataPut`, `CAUVResponseLocationMetadataRemove`, `CAUVResponseLocationPut`, `CAUVResponseLocationTypesAssign`, `CAUVResponseLocationTypesRevoke`, `CAUVResponseLogin`, `CAUVResponseRolesAssign`, `CAUVResponseRolesGet`, `CAUVResponseRolesRevoke`, `CAUVResponseStockCount`, `CAUVResponseStockReposit`, `CAUVResponseStockSearch`, `CAUVResponseTypePackageGetText`, `CAUVResponseTypePackageInstall`, `CAUVResponseTypePackageSearch`, `CAUVResponseTypePackageUninstall`, `CAUVResponseTypePackageUpgrade`, `CAUVSizeRange`, `CAUVStockOccurrence`, `CAUVStockOccurrenceKind`, `CAUVStockReposit`, `CAUVStockSearchParameters`, `CAUVStrings`, `CAUVTimeRange`, `CAUVTypeField`, `CAUVTypePackageIdentifier`, `CAUVTypePackageSearchParameters`, `CAUVTypePackageSummary`, `CAUVTypePackageTypeRemovalBehavior`, `CAUVTypePackageUninstall`, `CAUVTypePackageVersionBehavior`, `CAUVTypeRecord`, `CAUVTypeRecordFieldIdentifier`, `CAUVTypeRecordIdentifier`, `CAUVTypeRecordSearchParameters`, `CAUVTypeRecordSummary`, `CAUVTypeScalar`, `CAUVTypeScalarIdentifier`, `CAUVTypeScalarSearchParameters`, `CAUVVersion`

public interface CAProtocolMessageValidatorType<T,R>
The type of validators that convert between core messages and "wire" (versioned) messages.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `T`
  `convertFromWire(R message)`
  Convert a wire message to a core message.
  `R`
  `convertToWire(T message)`
  Convert a core message to a wire message.

- ## Method Details

  - ### convertToWire

    R convertToWire(T message) throws CAProtocolException
    Convert a core message to a wire message.
    Parameters:
      `message` - The core message
    Returns:
      The wire message
    Throws:
      `CAProtocolException` - On errors

  - ### convertFromWire

    T convertFromWire(R message) throws CAProtocolException
    Convert a wire message to a core message.
    Parameters:
      `message` - The wire message
    Returns:
      The core message
    Throws:
      `CAProtocolException` - On errors